﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;
using System.Diagnostics;

namespace WinTreeCheckState
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
           
        }

        private void ultraTree1_AfterCheck(object sender, Infragistics.Win.UltraWinTree.NodeEventArgs e)
        {
            ultraTree1.AfterCheck -= new Infragistics.Win.UltraWinTree.AfterNodeChangedEventHandler(ultraTree1_AfterCheck);
            foreach (UltraTreeNode node in e.TreeNode.Nodes)
            {
                DownChange(node, e.TreeNode.CheckedState);
                node.CheckedState = e.TreeNode.CheckedState;
            }
            UpChange(e.TreeNode);
            ultraTree1.AfterCheck += new Infragistics.Win.UltraWinTree.AfterNodeChangedEventHandler(ultraTree1_AfterCheck);
           
        }

        private void UpChange(UltraTreeNode node)
        {
            if (node.Parent != null)
            {
                Dictionary<CheckState, int> states = new Dictionary<CheckState, int>();
                foreach (CheckState c in Enum.GetValues(typeof(CheckState)))
                    states.Add(c, 0);
                foreach (UltraTreeNode n in node.Parent.Nodes)
                    states[n.CheckedState]++;
                if (states[CheckState.Checked] == node.Parent.Nodes.Count)
                    PopulateUp(node, CheckState.Checked);
                else if (states[CheckState.Unchecked] == node.Parent.Nodes.Count)
                    PopulateUp(node, CheckState.Unchecked);
                else
                    PopulateUp(node, CheckState.Indeterminate);
            }

        }

        private void PopulateUp(UltraTreeNode node, CheckState checkState)
        {
            if (node.Parent == null)
                return;
            node.Parent.CheckedState = checkState;
            PopulateUp(node.Parent, checkState);
        }

        private void DownChange(UltraTreeNode node, CheckState checkState)
        {
            foreach (UltraTreeNode n in node.Nodes)
            {
                DownChange(n, checkState);
                n.CheckedState = checkState;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraTree1.ExpandAll();
        }
    }
}
